
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Voyager.voyager_strategy module &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="prev" title="Voyager.voyager_dag module" href="Voyager.voyager_dag.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="Voyager.voyager_dag.html" title="Voyager.voyager_dag module"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="modules.html" >src</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="Voyager.html" accesskey="U">Voyager package</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="Voyager.voyager_dag.html"
                        title="previous chapter">Voyager.voyager_dag module</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/Voyager.voyager_strategy.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-Voyager.voyager_strategy">
<span id="voyager-voyager-strategy-module"></span><h1>Voyager.voyager_strategy module<a class="headerlink" href="#module-Voyager.voyager_strategy" title="Permalink to this headline">¶</a></h1>
<p>The module is collecting the exceptions and the classes to manage the strategy graph and its states.:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1">###################################################################################################</span>
<span class="c1">#                                          LICENSE                                                #</span>
<span class="c1"># PhaserVoyager is distributed under three different licences                                     #</span>
<span class="c1">#                                                                                                 #</span>
<span class="c1"># [Academic Licence](http://www.phaser.cimr.cam.ac.uk/index.php/Academic_Licence)                 #</span>
<span class="c1"># [CCP4 Licence](http://www.phaser.cimr.cam.ac.uk/index.php/CCP4_Licence)                         #</span>
<span class="c1"># [Phenix Licence](http://www.phaser.cimr.cam.ac.uk/index.php/Phenix_Licence)                     #</span>
<span class="c1">#                                                                                                 #</span>
<span class="c1"># By accessing the source code in this repository you agree to be bound by one of these licences. #</span>
<span class="c1">#                   (c) 2000-2020 Cambridge University Technical Services Ltd                     #</span>
<span class="c1">#                                                                                                 #</span>
<span class="c1">###################################################################################################</span>
</pre></div>
</div>
<dl class="exception">
<dt id="Voyager.voyager_strategy.StrategyError">
<em class="property">exception </em><code class="descclassname">Voyager.voyager_strategy.</code><code class="descname">StrategyError</code><span class="sig-paren">(</span><em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#StrategyError"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.StrategyError" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal notranslate"><span class="pre">exceptions.Exception</span></code></p>
<p>StrategyError is an Exception that is raised within the VoyagerStrategy class or the StrategyState.
It encapsulate errors at running time generated directly from the Strategy Graph.</p>
</dd></dl>

<dl class="class">
<dt id="Voyager.voyager_strategy.StrategyState">
<em class="property">class </em><code class="descclassname">Voyager.voyager_strategy.</code><code class="descname">StrategyState</code><span class="sig-paren">(</span><em>phasertng_dir</em>, <em>namestate</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#StrategyState"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.StrategyState" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference external" href="https://docs.python.org/3/library/functions.html#object" title="(in Python v3.8)"><code class="xref py py-class docutils literal notranslate"><span class="pre">object</span></code></a></p>
<p>A StrategyState object describe the state of a StrategyGraph for a particular VoyagerDag.
A new StrategyState is usually created when the original VoyagerDag has to be branched to separate
alternative parametrisation for the same actions or alternative data input (alternative tncs orders, spacegroups …)</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>voyager_dag</strong> (<a class="reference internal" href="Voyager.voyager_dag.html#Voyager.voyager_dag.VoyagerDag" title="Voyager.voyager_dag.VoyagerDag"><em>voyager_dag.VoyagerDag</em></a>) – the Dag that is managed by the State. See the documentation relative to VoyagerDag for more details.</li>
<li><strong>state_name</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a>) – A label associated to the State. It can be used by phaser.voyager.VoyagerGUI to display the voyager_dag with a name.</li>
<li><strong>current_strategy_node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – The ID of the node for the current running strategy action.</li>
<li><strong>action_completed</strong> (<em>dict {strategy_node_id:</em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em><em>}</em>) – Store all the actions already executed and the ids of their produced output voyager_dag nodes.</li>
<li><strong>action_finished</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em> [</em><em>strategy_node_id1</em><em>, </em><em>strategy_node_id2</em><em>, </em><em>..</em><em>]</em>) – Store all the actions that have finished.</li>
<li><strong>ended_branches</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>[</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>] </em><em>[</em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em><em>, </em><em>[</em><em>voyager_dag_id3</em><em>, </em><em>voyager_dag_id4</em><em>, </em><em>..</em><em>]</em><em>, </em><em>..</em><em>]</em>) – Store all the branches of the voyager_dag that have already reach an end.</li>
<li><strong>branches_opened</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>[</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>] </em><em>[</em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em><em>, </em><em>[</em><em>voyager_dag_id3</em><em>, </em><em>voyager_dag_id4</em><em>, </em><em>..</em><em>]</em><em>, </em><em>..</em><em>]</em>) – Store all the branches of the voyager_dag that have opened and not yet finished. E.g.: several tncs corrections</li>
<li><strong>register_to_watch</strong> (<em>dict {strategy_node_id :</em><em> (</em><em>[</em><em>voyager_dag_bound_id1</em><em>, </em><em>voyager_dag_bound_id2</em><em>]</em><em>, </em><em>priority_float</em><em>)</em>) – Store all the actions that has to be monitored for their completion to trigger the joining of two (or more) branches of the voyager_dag.</li>
<li><strong>strategy_conditionals_conts</strong> (<em>dict {name_of_the_conditional_func: int_counter}</em>) – Store the counts of how many time a conditional defined in a subclass of voyager_strategy.VoyagerStrategy</li>
<li><strong>actions_params</strong> (<em>dict {strategy_node_id: phil_str_params}</em>) – Store the parametrisation associated to each action when voyager_strategy.AIagent is active</li>
<li><strong>end_reached</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#set" title="(in Python v3.8)"><em>set</em></a>) – Set of all the end actions reached by the strategy.</li>
<li><strong>running_actions</strong> (<em>dict {strategy_node_id: tuple_instruction}</em>) – Store the current running action instructions. An instruction is a tuple with several data used to spawn a new action execution.</li>
<li><strong>branched_from</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID reference of the StrategyState from which the current state has been branched out. If it is the root state then branched_from is None</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="exception">
<dt id="Voyager.voyager_strategy.ValidationError">
<em class="property">exception </em><code class="descclassname">Voyager.voyager_strategy.</code><code class="descname">ValidationError</code><span class="sig-paren">(</span><em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#ValidationError"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.ValidationError" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal notranslate"><span class="pre">exceptions.Exception</span></code></p>
<p>ValidationError is an Exception that is raised during the validation step before running a strategy.
Actions composing a strategy are tested and their imports checked. If an error is raised will be sent as a ValidationError.</p>
</dd></dl>

<dl class="class">
<dt id="Voyager.voyager_strategy.VoyagerStrategy">
<em class="property">class </em><code class="descclassname">Voyager.voyager_strategy.</code><code class="descname">VoyagerStrategy</code><span class="sig-paren">(</span><em>argsparse</em>, <em>program_master_phil</em>, <em>states=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference external" href="https://docs.python.org/3/library/functions.html#object" title="(in Python v3.8)"><code class="xref py py-class docutils literal notranslate"><span class="pre">object</span></code></a></p>
<p>A VoyagerStrategy handles the strategy graph and all the attributes required to inspect, analyse, modify, interpret and execute it.
A strategy graph in the Voyager context is similar to a flow-chart in which the actions are nodes as task to be executed while the order
of this execution and the way in which are connected to each other is established by the edge connections. The strategy can present conditionals,
while loops, parallell and sequential iterations, parallel and sequential branching and many more operations that modify the strategy graph execution
at running time.</p>
<p>A real implementation of a strategy can be designed with the StrategyGUI.strategy_app graphical application.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>phasertng_dir</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a>) – Directory path where all the phasertng calculation should performed</li>
<li><strong>states</strong> (<a class="reference internal" href="MDSLibraries.simple_tools.html#MDSLibraries.simple_tools.NotRemovableList" title="MDSLibraries.simple_tools.NotRemovableList"><em>simple_tools.NotRemovableList</em></a><em> [</em><a class="reference internal" href="#Voyager.voyager_strategy.StrategyState" title="Voyager.voyager_strategy.StrategyState"><em>voyager_strategy.StrategyState</em></a><em>, </em><em>..</em><em>]</em>) – List of voyager_strategy.StrategyState that the strategy is currently managing.
The index position in the list is also the ID of the StrategyState.
This list can only be increased in size. StrategyStates canno be removed.</li>
<li><strong>tng</strong> (<a class="reference internal" href="MDSLibraries.phasertng_wrapper.html#MDSLibraries.phasertng_wrapper.TNG" title="MDSLibraries.phasertng_wrapper.TNG"><em>phasertng_wrapper.TNG</em></a>) – Instance of the TNG class. From this object any phasertng operation is executed.</li>
<li><strong>G</strong> (<em>networkx.DiGraph</em>) – Instance of a directed graph representing the strategy graph.</li>
<li><strong>verbose</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.8)"><em>bool</em></a>) – Activate the verbose mode, in which detailed output is printed on the screen.</li>
<li><strong>arguments</strong> (<em>libtbx.phil.scope</em>) – Python object representing the input for the strategy. User input provided by command line or phil file
are already merged with the strategy default phil and the masterphil.</li>
<li><strong>program_master_phil</strong> (<em>libtbx.phil</em>) – Phil object representing the masterphil of the strategy.</li>
<li><strong>ai_agent</strong> (<em>Aiagent.AiAgent</em>) – reference of an AiAgent object. The agent will be in charge of parameterize new actions, branching the VoyagerDag and checking
for ending conditions. See Aiagent.AiAgent for the details.</li>
<li><strong>guicallback_action_start</strong> (<em>func</em>) – Reference to a callback function managed by the phaser.voyager.VoygaerGUI to trigger visualization of a started action</li>
<li><strong>guicallback_action_end</strong> (<em>func</em>) – Reference to a callback function managed by the phaser.voyager.VoygaerGUI to trigger visualization of an ended action</li>
<li><strong>guicallback_action_error</strong> (<em>func</em>) – Reference to a callback function managed by the phaser.voyager.VoygaerGUI to trigger visualization of an error in an action</li>
<li><strong>guicallback_action_warning</strong> (<em>func</em>) – Reference to a callback function managed by the phaser.voyager.VoygaerGUI to trigger visualization of a warning in an action</li>
<li><strong>guicallback_add_new_dag</strong> (<em>func</em>) – Reference to a callback function managed by the phaser.voyager.VoygaerGUI to trigger visualization of a new voyager_dag.VoyagerDag created</li>
<li><strong>scheduler_queue_receive</strong> (<a class="reference internal" href="MDSLibraries.simple_tools.html#MDSLibraries.simple_tools.MultiProcessingPriorityQueue" title="MDSLibraries.simple_tools.MultiProcessingPriorityQueue"><em>simple_tools.MultiProcessingPriorityQueue</em></a>) – Main Queue to manage action instructions to be executed. It allows to manage several voyager_strategy.StrategyState in parallel and to use priorities.</li>
<li><strong>scheduler_queue_send</strong> (<a class="reference internal" href="MDSLibraries.simple_tools.html#MDSLibraries.simple_tools.MultiProcessingPriorityQueue" title="MDSLibraries.simple_tools.MultiProcessingPriorityQueue"><em>simple_tools.MultiProcessingPriorityQueue</em></a>) – Manage the Queue with results of specific instructions generated in a voyager_actions.Action subclass.
It usually contains the return of the manipulation of a voyager_dag.VoyagerDag.</li>
<li><strong>new_object</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.8)"><em>bool</em></a>) – Inform the strategy if it is an object created from scratch or if it has been imported from a pickled object as result of loading a pre-existing job.</li>
<li><strong>end_points</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#set" title="(in Python v3.8)"><em>set</em></a>) – Set of all defined end point for the current strategy graph. Include both end node type and end_strategy node type</li>
</ul>
</td>
</tr>
</tbody>
</table>
<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_action_edge">
<code class="descname">add_action_edge</code><span class="sig-paren">(</span><em>ind1</em>, <em>ind2</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_action_edge"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_action_edge" title="Permalink to this definition">¶</a></dt>
<dd><table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>ind1</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the starting node of the edge.</li>
<li><strong>ind2</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the ending node of the edge.</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_action_node">
<code class="descname">add_action_node</code><span class="sig-paren">(</span><em>action</em>, <em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_action_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_action_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add a new action in the strategy graph.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>action</strong> (<em>voyager_actions.Action</em>) – Action to be added in the strategy_graph</li>
<li><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"></p>
</td>
</tr>
<tr class="field-odd field"><th class="field-name">Return type:</th><td class="field-body"><p class="first last"></p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_conditional_node">
<code class="descname">add_conditional_node</code><span class="sig-paren">(</span><em>conditional_callback</em>, <em>iftrue</em>, <em>iffalse</em>, <em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_conditional_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_conditional_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add a conditional node in the strategy graph. The result of the condition will choose which of the two alternative paths
must be executed at running time.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>conditional_callback</strong> (<em>func</em>) – Reference to a function implemented in a subclass of voyager_strategy.VoyagerStrategy subclass.
the callback function will perform the conditional evaluation.</li>
<li><strong>iftrue</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the action node that has to be executed is the result of the conditional is True at running time</li>
<li><strong>iffalse</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the action node that has to be executed is the result of the conditional is False at running time</li>
<li><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_consumer_node">
<code class="descname">add_consumer_node</code><span class="sig-paren">(</span><em>**kwargs</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_consumer_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_consumer_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add a producer consumer to the strategy graph
:param producer: Producer action to be added
:type producer: voyager_actions.Action
:param consumer: Consumer action to be added
:type consumer: voyager_actions.Action
:param parent: ID of the parent node. If no parent available or specified than parent is None
:type parent: int</p>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_end_node">
<code class="descname">add_end_node</code><span class="sig-paren">(</span><em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_end_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_end_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add an end node to the strategy graph</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_end_strategy_node">
<code class="descname">add_end_strategy_node</code><span class="sig-paren">(</span><em>parent</em>, <em>name</em>, <em>silent</em>, <em>start</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_end_strategy_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_end_strategy_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add a end_strategy node in the strategy graph.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</li>
<li><strong>name</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a>) – Strategy name</li>
<li><strong>silent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.8)"><em>bool</em></a>) – Define if the ending of the strategy must be silent or should trigger then end of the program.
A silent strategy ending is required when the strategy is enclosed in a bigger strategy.</li>
<li><strong>start</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the strategy node where the strategy started.
This information is important to correctly collapse a substrategy in a single node when is part a bigger strategy.</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_endwhile_node">
<code class="descname">add_endwhile_node</code><span class="sig-paren">(</span><em>goto</em>, <em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_endwhile_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_endwhile_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add an end while loop node in the computation graph.
This node will point back to the beginning of the while loop to check again for the conditional and proceed
with another iteration or end the while.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>goto</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the action where the current while loop is started to continue with another iteration.</li>
<li><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_join_node">
<code class="descname">add_join_node</code><span class="sig-paren">(</span><em>bounded_nodes</em>, <em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_join_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_join_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add a join in the computation graph.
The Join happens when parallel branches of the strategy graph are executed and they have to be finished before to joining the
execution in one thread and continue from there with the current voyager_dag.VoyagerDag.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>bounded_nodes</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a>) – IDs of all the action nodes that has to finish before the join can be executed.</li>
<li><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_loop_parallel_data_node">
<code class="descname">add_loop_parallel_data_node</code><span class="sig-paren">(</span><em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_loop_parallel_data_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_loop_parallel_data_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add new parallel iteration over voyager_dag.VoyagerDag hkl data nodes</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_loop_parallel_models_node">
<code class="descname">add_loop_parallel_models_node</code><span class="sig-paren">(</span><em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_loop_parallel_models_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_loop_parallel_models_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add new parallel iteration over voyager_dag.VoyagerDag pdb nodes</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_loop_parallel_molecules_node">
<code class="descname">add_loop_parallel_molecules_node</code><span class="sig-paren">(</span><em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_loop_parallel_molecules_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_loop_parallel_molecules_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add new parallel iteration over voyager_dag.VoyagerDag molecule nodes</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_loop_sequence_data_node">
<code class="descname">add_loop_sequence_data_node</code><span class="sig-paren">(</span><em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_loop_sequence_data_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_loop_sequence_data_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add new sequential iteration over voyager_dag.VoyagerDag hkl data nodes</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_loop_sequence_models_node">
<code class="descname">add_loop_sequence_models_node</code><span class="sig-paren">(</span><em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_loop_sequence_models_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_loop_sequence_models_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add new sequential iteration over voyager_dag.VoyagerDag pdb nodes</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_loop_sequence_molecules_node">
<code class="descname">add_loop_sequence_molecules_node</code><span class="sig-paren">(</span><em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_loop_sequence_molecules_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_loop_sequence_molecules_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add new sequential iteration over voyager_dag.VoyagerDag molecule nodes</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_parallel_node">
<code class="descname">add_parallel_node</code><span class="sig-paren">(</span><em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_parallel_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_parallel_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add new parallel branch to the strategy graph</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_producer_node">
<code class="descname">add_producer_node</code><span class="sig-paren">(</span><em>**kwargs</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_producer_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_producer_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add a producer action to the strategy graph
:param producer: Producer action to be added
:type producer: voyager_actions.Action
:param parent: ID of the parent node. If no parent available or specified than parent is None
:type parent: int</p>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_selector_node">
<code class="descname">add_selector_node</code><span class="sig-paren">(</span><em>selection_callback</em>, <em>nextaction</em>, <em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_selector_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_selector_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add a selector node in the strategy graph.
Selection filter some nodes of the voyager_dag.VoyagerDag before executing the next action.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>selection_callback</strong> (<em>func</em>) – Reference to a function implemented in a subclass of voyager_strategy.VoyagerStrategy subclass.
The callback function will perform the selection evaluation over some voyager_dag.VoyagerDag nodes.</li>
<li><strong>nextaction</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the action to be executed passing as input the selected voyager_dag.VoyagerDag nodes</li>
<li><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.add_startwhile_node">
<code class="descname">add_startwhile_node</code><span class="sig-paren">(</span><em>conditional_callback</em>, <em>iftrue</em>, <em>iffalse</em>, <em>parent</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.add_startwhile_node"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.add_startwhile_node" title="Permalink to this definition">¶</a></dt>
<dd><p>Add a while loop node in the strategy graph. a condition will be checked and the actions within the loop will be executed
until the condition is held to be true. Then the execution will continue following the iffalse path.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>conditional_callback</strong> (<em>func</em>) – Reference to a function implemented in a subclass of voyager_strategy.VoyagerStrategy subclass.
the callback function will perform the conditional evaluation.</li>
<li><strong>iftrue</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the action node that has to be executed every time the result of the conditional is True at running time</li>
<li><strong>iffalse</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the action node that has to be executed every time the result of the conditional is False at running time</li>
<li><strong>parent</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node. If no parent available or specified than parent is None</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.check_if_ending">
<code class="descname">check_if_ending</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.check_if_ending"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.check_if_ending" title="Permalink to this definition">¶</a></dt>
<dd><p>Determine if the strategy has ended and stops any agent watching for the strategy graph and its queues.
The program will terminate when all the open branches have finished</p>
<p>NOTE: The AIagent.AIAgent can decide if the run should be terminated early through the analyse method.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Return end:</th><td class="field-body">the strategy has ended and the watching over the strategy queues must be ended.</td>
</tr>
<tr class="field-even field"><th class="field-name">Return type:</th><td class="field-body"><a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.8)">bool</a></td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.check_registered_actions">
<code class="descname">check_registered_actions</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.check_registered_actions"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.check_registered_actions" title="Permalink to this definition">¶</a></dt>
<dd><p>Check all the registered actions to establish if they are finished.
If it is the case it will merge the branches of the involved join.</p>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.update_ended_branches">
<code class="descname">update_ended_branches</code><span class="sig-paren">(</span><em>state_id</em>, <em>input</em>, <em>node</em>, <em>parentnode</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.update_ended_branches"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.update_ended_branches" title="Permalink to this definition">¶</a></dt>
<dd><p>Perform the final operation before ending the strategy. It cleans the variables and check the condition of all the dags and opened branches.
TODO: Make sure to close the db connection
TODO: Write down the json graph for the current graph
TODO: Eventually store the dag in the database we will see what is convenient
TODO: Wait for any pending process before ending</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the voyager_strategy.StrategyState to inspect</li>
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – list of input nodes of a voyager_dag.VoyagerDag graph from which reconstruct the ended branches</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the ending node</li>
<li><strong>parentnode</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent node</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Return ending:</th><td class="field-body"><p class="first">It is True if the strategy is ending</p>
</td>
</tr>
<tr class="field-odd field"><th class="field-name">Return type:</th><td class="field-body"><p class="first last"><a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.8)">bool</a></p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.prepare_termination_conditions">
<code class="descname">prepare_termination_conditions</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.prepare_termination_conditions"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.prepare_termination_conditions" title="Permalink to this definition">¶</a></dt>
<dd><p>Inspect the strategy graph to determine what are the ending points discriminating excluding the silent one.
Modify self.end_points attribute.</p>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.run">
<code class="descname">run</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.run"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.run" title="Permalink to this definition">¶</a></dt>
<dd><p>It starts and endless loop that can only stopped when the strategy has finished, early terminated by the AIagent.AiAgent or fails.
The loop inspect the queues associated to the strategy and pick the action that has to be executed next (considering states and priorities).
the loop manage interaction with actions, manipulation of the dags, and execution of parallel and sequential actions.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Raises:</th><td class="field-body"><strong>ex</strong> – An Exception can be raised if an Action fail and the Strategy does not know how to manage that failure, or if the strategy itself fails.</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.run_action">
<code class="descname">run_action</code><span class="sig-paren">(</span><em>input</em>, <em>node</em>, <em>state_id</em>, <em>priority</em>, <em>new_keywords</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.run_action"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.run_action" title="Permalink to this definition">¶</a></dt>
<dd><p>Run the action.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – IDs of the input nodes of the voyager_dag.VoyagerDag for the next action</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the action to run</li>
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the current voyager_strategy.StrategyState</li>
<li><strong>priority</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.8)"><em>float</em></a>) – priority associated to the action</li>
<li><strong>new_keywords</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a>) – Phil keywords that has to be updated before the execution of the action</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Raises:</th><td class="field-body"><p class="first last"><strong>ex</strong> – raise an Exception if the action fails and it is not possible to recover the error.</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.run_conditional">
<code class="descname">run_conditional</code><span class="sig-paren">(</span><em>input</em>, <em>node</em>, <em>parentnode</em>, <em>state_id</em>, <em>priority</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.run_conditional"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.run_conditional" title="Permalink to this definition">¶</a></dt>
<dd><p>Run a conditional node executing the callback function and queueing the correct next action.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – IDs of the input nodes of the voyager_dag.VoyagerDag for the next action</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the conditional action</li>
<li><strong>parentnode</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent action node</li>
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the current voyager_strategy.StrategyState</li>
<li><strong>priority</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.8)"><em>float</em></a>) – priority associated to the action</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.run_endwhile">
<code class="descname">run_endwhile</code><span class="sig-paren">(</span><em>input</em>, <em>node</em>, <em>parentnode</em>, <em>state_id</em>, <em>priority</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.run_endwhile"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.run_endwhile" title="Permalink to this definition">¶</a></dt>
<dd><p>Run an endwhile action linking the next action to be executed to the starting node of the current while loop.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – IDs of the input nodes of the voyager_dag.VoyagerDag for the next action</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the conditional action</li>
<li><strong>parentnode</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent action node</li>
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the current voyager_strategy.StrategyState</li>
<li><strong>priority</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.8)"><em>float</em></a>) – priority associated to the action</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.run_join">
<code class="descname">run_join</code><span class="sig-paren">(</span><em>input</em>, <em>node</em>, <em>parentnode</em>, <em>state_id</em>, <em>priority</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.run_join"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.run_join" title="Permalink to this definition">¶</a></dt>
<dd><p>Execute a Join node. This function will register for monitoring the bounded actions to this join and the merge of
the involved branches will happen only those actions will be all finished.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – IDs of the input nodes of the voyager_dag.VoyagerDag for the next action</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the conditional action</li>
<li><strong>parentnode</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent action node</li>
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the current voyager_strategy.StrategyState</li>
<li><strong>priority</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.8)"><em>float</em></a>) – priority associated to the action</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.run_loop_parallel_data">
<code class="descname">run_loop_parallel_data</code><span class="sig-paren">(</span><em>input</em>, <em>node</em>, <em>parentnode</em>, <em>state_id</em>, <em>priority</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.run_loop_parallel_data"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.run_loop_parallel_data" title="Permalink to this definition">¶</a></dt>
<dd><p>Prepare to execute in parallel the different opened hkl data branches in the input list.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – IDs of the input nodes of the voyager_dag.VoyagerDag for the next action</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the conditional action</li>
<li><strong>parentnode</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent action node</li>
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the current voyager_strategy.StrategyState</li>
<li><strong>priority</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.8)"><em>float</em></a>) – priority associated to the action</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.run_loop_parallel_models">
<code class="descname">run_loop_parallel_models</code><span class="sig-paren">(</span><em>input</em>, <em>node</em>, <em>parentnode</em>, <em>state_id</em>, <em>priority</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.run_loop_parallel_models"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.run_loop_parallel_models" title="Permalink to this definition">¶</a></dt>
<dd><p>Prepare to execute in parallel the different opened pdb model branches in the input list.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – IDs of the input nodes of the voyager_dag.VoyagerDag for the next action</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the conditional action</li>
<li><strong>parentnode</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent action node</li>
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the current voyager_strategy.StrategyState</li>
<li><strong>priority</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.8)"><em>float</em></a>) – priority associated to the action</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.run_loop_parallel_molecules">
<code class="descname">run_loop_parallel_molecules</code><span class="sig-paren">(</span><em>input</em>, <em>node</em>, <em>parentnode</em>, <em>state_id</em>, <em>priority</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.run_loop_parallel_molecules"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.run_loop_parallel_molecules" title="Permalink to this definition">¶</a></dt>
<dd><p>Prepare to execute in parallel the different opened molecule branches in the input list.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – IDs of the input nodes of the voyager_dag.VoyagerDag for the next action</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the conditional action</li>
<li><strong>parentnode</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent action node</li>
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the current voyager_strategy.StrategyState</li>
<li><strong>priority</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.8)"><em>float</em></a>) – priority associated to the action</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.run_loop_sequence_data">
<code class="descname">run_loop_sequence_data</code><span class="sig-paren">(</span><em>input</em>, <em>node</em>, <em>parentnode</em>, <em>state_id</em>, <em>priority</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.run_loop_sequence_data"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.run_loop_sequence_data" title="Permalink to this definition">¶</a></dt>
<dd><p>Prepare to execute in sequence the different opened hkl data branches in the input list.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – IDs of the input nodes of the voyager_dag.VoyagerDag for the next action</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the conditional action</li>
<li><strong>parentnode</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent action node</li>
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the current voyager_strategy.StrategyState</li>
<li><strong>priority</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.8)"><em>float</em></a>) – priority associated to the action</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.run_loop_sequence_models">
<code class="descname">run_loop_sequence_models</code><span class="sig-paren">(</span><em>input</em>, <em>node</em>, <em>parentnode</em>, <em>state_id</em>, <em>priority</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.run_loop_sequence_models"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.run_loop_sequence_models" title="Permalink to this definition">¶</a></dt>
<dd><p>Prepare to execute in sequence the different opened pdb model branches in the input list.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – IDs of the input nodes of the voyager_dag.VoyagerDag for the next action</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the conditional action</li>
<li><strong>parentnode</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent action node</li>
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the current voyager_strategy.StrategyState</li>
<li><strong>priority</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.8)"><em>float</em></a>) – priority associated to the action</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.run_loop_sequence_molecules">
<code class="descname">run_loop_sequence_molecules</code><span class="sig-paren">(</span><em>input</em>, <em>node</em>, <em>parentnode</em>, <em>state_id</em>, <em>priority</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.run_loop_sequence_molecules"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.run_loop_sequence_molecules" title="Permalink to this definition">¶</a></dt>
<dd><p>Prepare to execute in sequence the different opened molecule branches in the input list.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – IDs of the input nodes of the voyager_dag.VoyagerDag for the next action</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the conditional action</li>
<li><strong>parentnode</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent action node</li>
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the current voyager_strategy.StrategyState</li>
<li><strong>priority</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.8)"><em>float</em></a>) – priority associated to the action</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.run_parallel">
<code class="descname">run_parallel</code><span class="sig-paren">(</span><em>input</em>, <em>node</em>, <em>parentnode</em>, <em>state_id</em>, <em>priority</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.run_parallel"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.run_parallel" title="Permalink to this definition">¶</a></dt>
<dd><p>Split the current strategy graph in several parallel branches.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – IDs of the input nodes of the voyager_dag.VoyagerDag for the next action</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the conditional action</li>
<li><strong>parentnode</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent action node</li>
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the current voyager_strategy.StrategyState</li>
<li><strong>priority</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.8)"><em>float</em></a>) – priority associated to the action</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.run_selection">
<code class="descname">run_selection</code><span class="sig-paren">(</span><em>input</em>, <em>node</em>, <em>parentnode</em>, <em>state_id</em>, <em>priority</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.run_selection"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.run_selection" title="Permalink to this definition">¶</a></dt>
<dd><p>Run the selection node. The callback condition function is executed and the filtered voyager_dag.VoyagerDag are sent as input for the next action.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – IDs of the input nodes of the voyager_dag.VoyagerDag for the next action</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the conditional action</li>
<li><strong>parentnode</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the parent action node</li>
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the current voyager_strategy.StrategyState</li>
<li><strong>priority</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.8)"><em>float</em></a>) – priority associated to the action</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.save_checkpoint">
<code class="descname">save_checkpoint</code><span class="sig-paren">(</span><em>to_store</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.save_checkpoint"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.save_checkpoint" title="Permalink to this definition">¶</a></dt>
<dd><p>Create a checkpoint and store in the disk the current status of the database, voyager_strategy.VoyagerStrategy with all its attributes
including all the voyager_strategy.StrategyState and voyager_dag.VoyagerDag and their queues.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>to_store</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#tuple" title="(in Python v3.8)"><em>tuple</em></a><em>) </em><em>[</em><em>tuple_instruction_1 tuple_instruction_2</em><em>, </em><em>..</em><em>]</em>) – List of the action instructions that are currently present in the queue.</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.skip_action">
<code class="descname">skip_action</code><span class="sig-paren">(</span><em>input</em>, <em>node</em>, <em>state_id</em>, <em>priority</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.skip_action"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.skip_action" title="Permalink to this definition">¶</a></dt>
<dd><p>Skip the action and execute its child/children in the strategy graph.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>input</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.8)"><em>list</em></a><em>(</em><a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.8)"><em>str</em></a><em>) </em><em>[</em><em>voyager_dag_id1</em><em>, </em><em>voyager_dag_id2</em><em>, </em><em>..</em><em>]</em>) – IDs of the input nodes of the voyager_dag.VoyagerDag for the next action</li>
<li><strong>node</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the action to be skipped</li>
<li><strong>state_id</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.8)"><em>int</em></a>) – ID of the current voyager_strategy.StrategyState</li>
<li><strong>priority</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.8)"><em>float</em></a>) – priority associated to the action</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="Voyager.voyager_strategy.VoyagerStrategy.validate_all">
<code class="descname">validate_all</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/Voyager/voyager_strategy.html#VoyagerStrategy.validate_all"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#Voyager.voyager_strategy.VoyagerStrategy.validate_all" title="Permalink to this definition">¶</a></dt>
<dd><p>Validate all the actions in the strategy graph. Validation implies that all the actions would not fail to call check_imports method.
This method will test that all involved action can import and thus can run in the current machine/python environment.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Raises:</th><td class="field-body"><a class="reference internal" href="#Voyager.voyager_strategy.ValidationError" title="Voyager.voyager_strategy.ValidationError"><strong>ValidationError</strong></a> – raised if an action cannot be validated</td>
</tr>
</tbody>
</table>
</dd></dl>

</dd></dl>

</div>


          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="Voyager.voyager_dag.html" title="Voyager.voyager_dag module"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="modules.html" >src</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="Voyager.html" >Voyager package</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>